searchNodes=[{"doc":"Convenience macros for doing comparisons","ref":"CompareChain.html","title":"CompareChain","type":"module"},{"doc":"Macro that performs chained comparison using operators like &lt; and combinations using and or , and not . Examples Chained comparison: iex&gt; import CompareChain iex&gt; compare? ( 1 &lt; 2 &lt; 3 ) true Comparisons joined by logical operators: iex&gt; import CompareChain iex&gt; compare? ( 1 &gt;= 2 &gt;= 3 or 4 &gt;= 5 &gt;= 6 ) false Notes You must include at least one comparison like &lt; in your expression. Failing to do so will result in a compile time error.","ref":"CompareChain.html#compare?/1","title":"CompareChain.compare?/1","type":"macro"},{"doc":"Similar to compare?/1 except you can provide a module that defines a compare/2 for semantic comparisons. This is like how you can provide a module as the second argument to Enum.sort/2 . See the notes in compare?/1 as they apply to compare?/2 as well. Examples Basic comparison (note how a &lt; b == false natively because of structural comparison): iex&gt; import CompareChain iex&gt; a = ~D[2017-03-31] iex&gt; b = ~D[2017-04-01] iex&gt; a &lt; b false iex&gt; compare? ( a &lt; b , Date ) true Chained comparison: iex&gt; import CompareChain iex&gt; a = ~D[2017-03-31] iex&gt; b = ~D[2017-04-01] iex&gt; c = ~D[2017-04-02] iex&gt; compare? ( a &lt; b &lt; c , Date ) true Comparisons joined by logical operators: iex&gt; import CompareChain iex&gt; a = ~T[15:00:00] iex&gt; b = ~T[16:00:00] iex&gt; c = ~T[17:00:00] iex&gt; compare? ( a &lt; b and b &gt; c , Time ) false More complex expressions: iex&gt; import CompareChain iex&gt; compare? ( %{ a : ~T[16:00:00] } . a &lt;= ~T[17:00:00] , Time ) true Custom module: iex&gt; import CompareChain iex&gt; defmodule AlwaysGreaterThan do iex&gt; def compare ( _left , _right ) , do : :gt iex&gt; end iex&gt; compare? ( 1 &gt; 2 &gt; 3 , AlwaysGreaterThan ) true","ref":"CompareChain.html#compare?/2","title":"CompareChain.compare?/2","type":"macro"},{"doc":"","ref":"readme.html","title":"CompareChain","type":"extras"},{"doc":"Provides convenience macros for comparisons which do: chained comparisons like a &lt; b &lt; c semantic comparisons using the structural operators &lt; , &gt; , &lt;= , and &gt;= combinations using and , or , and not Examples iex&gt; import CompareChain # Chained operators iex&gt; compare? ( 1 &lt; 2 &lt; 3 ) true # Semantic comparisons iex&gt; compare? ( ~D[2017-03-31] &lt; ~D[2017-04-01] , Date ) true # Semantic comparisons + logical operators iex&gt; compare? ( ~T[16:00:00] &lt; ~T[16:00:00] and not ~T[17:00:00] &gt;= ~T[17:00:00] , Time ) false # More complex expressions iex&gt; compare? ( %{ a : ~T[16:00:00] } . a &lt;= ~T[17:00:00] , Time ) true","ref":"readme.html#description","title":"CompareChain - Description","type":"extras"},{"doc":"Add compare_chain to your list of dependencies in mix.exs : def deps do [ { :compare_chain , &quot;~&gt; 0.1.0&quot; } ] end Documentation can be found at https://hexdocs.pm/compare_chain .","ref":"readme.html#installation","title":"CompareChain - Installation","type":"extras"},{"doc":"Once installed, you can add import CompareChain to your defmodule and you will have access to compare?/1 and compare?/2 .","ref":"readme.html#usage","title":"CompareChain - Usage","type":"extras"},{"doc":"Many languages provide syntactic sugar for chained comparisons. For example in Python, a &lt; b &lt; c would be evaluated as (a &lt; b) and (b &lt; c) . Elixir does not provide this. Instead, a &lt; b &lt; c is evaluated as (a &lt; b) &lt; c . Since a &lt; b is a boolean, that's probably not what you want. Further, operators like &lt; do structural comparison instead of semantic comparison. For most situations, you probably want to use compare/2 . From the docs : Show/Hide The comparison functions in this module perform structural comparison. This means structures are compared based on their representation and not on their semantic value. This is specially important for functions that are meant to provide ordering, such as `>/2`, ` =/2`, ` ~D[2017-04-01] ``` will return true because structural comparison compares the `:day` field before `:month` or `:year`. Therefore, when comparing structs, you often use the `compare/2` function made available by the structs modules themselves: ```elixir iex> Date.compare(~D[2017-03-31], ~D[2017-04-01]) :lt ``` The compare/2 approach works well in many situations, but even moderately complicated logic can be cumbersome. If we wanted the native equivalent of: iex&gt; compare? ( ~D[2017-03-31] &lt;= ~D[2017-04-01] &lt; ~D[2017-04-02] , Date ) we'd have to write: iex&gt; Date . compare ( ~D[2017-03-31] , ~D[2017-04-01] ) != :gt and Date . compare ( ~D[2017-04-01] ) , ~D[2017-04-02] ) == :lt The goal of both compare?/1 and compare?/2 is to provide the syntactic sugar for chained comparisons. With compare?/2 , there is the added benefit of being able to use the structural comparison operators for semantic comparison.","ref":"readme.html#background-and-motivation","title":"CompareChain - Background and motivation","type":"extras"},{"doc":"","ref":"changelog.html","title":"CHANGELOG","type":"extras"},{"doc":"Allow not in expressions","ref":"changelog.html#v0-2-0-2022-11-05","title":"CHANGELOG - v0.2.0 (2022-11-05)","type":"extras"},{"doc":"Initial release","ref":"changelog.html#v0-1-0-2022-11-03","title":"CHANGELOG - v0.1.0 (2022-11-03)","type":"extras"}]